﻿-- Work_Complete (My First Addon)
-- Author: PunksNotDead on Quel'Thalas
-- --------------------------------------------------------------------------------------------------------------------------
-- Ver. v7.0.0.20160719 Legion Pre-Patch (Drop 7/19/2016) PTR Fix for API Update UI_INFO_MESSAGE(arg1, arg2)
-- Ver. v6.2.0.20150711 Update for build 6.2.0.20216 bug fixes for Taanan Jungle Dailies
--                      -- recoded with function UNIT_QUEST_LOG_CHANGED(unitID)
--						-- remove code function QUEST_LOG_UPDATE(...)
--						-- Added debug slash command /workcompletedebug
-- Ver. v6.2.0.20150624 TOC Updated for Patch 6.2.0 dropped 6/23/2015
-- Ver. v6.1.0.20150225 Change *.WAV files to *.OGG for /PlaySoundFile after jukebox dropped
-- Ver. v6.1.0.20150224 TOC Update for Patch 6.1.0 dropped 2/24/2015
-- Ver. v6.0.3.20150101 add Plural Check for first word in multi word strings
-- Ver. v6.0.3.20141123 ReStructure Code for False Triggers
-- Ver. v6.0.3.20141119 bug Fix added bolCheckString = False; 
-- Ver. v6.0.3.20141118 Check for Double Null checks in strings @ 339
-- Ver. v6.0.3.20141115.2 Moved null check to line 269
-- Ver. v6.0.3.20141115.1 Fixed code for bliz gathering quests; when recieving " taken", and singular/plural strings
-- Ver. v6.0.3.20141103.2 LUA error check for 318 attempt to concatenate local myLeaderBoardText a nil value
-- Ver. 2014-10-19 6.02.01 Code Clean up for double soundfiles / PVP Option Screen Bug fix
-- Ver. 2014-10-15 6.02.01 Updated for API GetQuestLogTitle
-- Ver. 2014-10-14 TOC 6.00.00 Update for Patch 6.0.2.19033 dropped 10/14/14 Warlords pre Patch.
-- Ver. 2014-06-04 lower case file extensions for Curse Client
-- Ver. 2014-06-03 TOC 5.04.00, Upgraded SVN 1.8.7.25475 & Update SVN Config, Force LF,EOL=Unix=Native
-- Ver. 2013-09-10 Updated TOC for 5.02.00 Patch dropped on 9/10/2013
-- Ver. 2013-08-11 svn:eol-style=native
-- Ver. 2013-05-21 Changed EOL Conversion to Unix/OSX
-- Ver. 2013-05-21 Updated TOC for 5.03.00 Patch dropped on 5/21/2013
-- Ver. 2013-03-27 UTF-8 BOM with Unix EOL
-- Ver. 2013-03-26 Changed Encoding to UTF-8 with BOM
-- Ver. 2013-03-06 Changed EOL Conversion to Unix/OSX for Client Status
-- Ver. 2013-03-05 Updated TOC for 5.02.00 Patch dropped on 03/05/2013
-- Ver. 2012-12-01 Updated TOC for 5.01.00 Patch dropped on 11/27/2012
-- Ver. 2012-08-29 Updated TOC for 5.00.04
--	 				New API GetNumGroupMembers() which replaces GetNumGroupMembers()
-- VER. 2012-01-06 Cleanup code & bug fix
-- ver. 2012-01-03 Fixed found bug with Grisly Trophy Option bit
-- ver. 2012-01-02 Added ByPass For DMF Grisly Trophy Quest 
-- ver. 2011-11-29 Updated TOC for 4.3
-- ver. 2011-07-10 Added an Options Page in the Blizz -Interface-Addons
--                 -- Added CheckBoxes to turn on or off chat and sound
--                 -- Added SavedVariables to retain selections
--                 -- first used of RGB colors.
--                 -- first use of structured variables
-- ver. 2011-06-30 Updated for 4.2 & TortoiseSVN Repo
-- Ver. 2011-06-13 Added Code to send Status To Party chat 
-- Ver. 2011-06-09 Removed PVPWarning @ Load
-- Ver. 2011-05-12 Original Code
-- --------------------------------------------------------------------------------------------------------------------------
-- Lua Format Structure Notes:
-- --------------------------------------------------------------------------------------------------------------------------
	-- Lua String Patterns: Character Classes
	-- . Represents all characters
	-- %a Represents all letters
	-- %d Represents all digits
	-- %s Represents all space characters
	-- Patterns;
	-- A single character class, which matches any single character within the class.
	-- A single character class followed by *, which matches 0 or more repetitions of characters in the class. These repetition items will always match the longest possible sequence.
	-- A single character class followed by +, which matches 1 or more repetitions of characters in the class. These repetition items will always match the longest possible sequence.
	-- A single character class followed by -, which also matches 0 or more repetitions of characters in the class. Unlike *, these repetition items will always match the shortest possible sequence.
	-- A single character class followed by ?, which matches 0 or 1 occurrences of a character in the class.
	-- so in the above:
	-- (.*):%s* matches all characters in a sequence until the ":" followed by space character (0 or more)
	-- ([%d]+)%s*/%s*([%d]+) matches all digits (+ means 1 or more digits) white space(0 or more) Slash(/) all digits(+ means 1 or more)
-- --------------------------------------------------------------------------------------------------------------------------
--
--
--
--
--
--
--
--
--
-- LUA: Main Code, Events(API) & Functions
-- 
-- Create a new UI Frame in game for the Addon
-- newFrame = CreateFrame("frameType"[, "frameName"[, parentFrame[, "inheritsFrame"]]]);
local frmMyFrame = CreateFrame("Frame") -- Define a frame for WOW to interface with this code
local intUpdatedQuestIndex = nil   -- This will contain the quest ID # of the updated Quest
local SoundWorkComplete = "Sound\\Creature\\Peon\\PeonBuildingComplete1.ogg"
local SoundReadyToWork =  "Sound\\Creature\\Peon\\PeonReady1.ogg"
local PVPWarningHorde = "Sound\\Interface\\PVPWarningHordeMono.ogg"
local PVPWarningAlliance = "Sound\\Interface\\PVPWarningAllianceMono.ogg"
local ReadyCheck ="ReadyCheck"
local strMSG ="" -- holds the text from the Leader Board for an updated Quest
local strUISentMSG ="" -- holds the text sent by Wow User Interface
local strPlayerID = ""
local True="1"
local False="0"
local bolDebug = false
-- define colors using hex R,G,B in cffRRGGBB format
local myWhite = "|cffffffff"
local myRed   = "|cffff0000"
local myGreen = "|cff00ff00"
local myBlue  = "|cff0080ff"
local myYellow= "|cffffff00"
-- --------------------------------------------------------------------------------------------------------------------------
WorkComplete = {
	Defaults = {
		OneShot = true;            -- 1-Shot
		PVPHorde = true;           -- PVPHorde;      
		PVPAlliance = false;       -- PVPAlliance;   
		SoundReady = true;         -- SoundReady;    
		SoloReady = true;          -- SoloReady;     
		PartyReady = true;         -- PartyReady;    
		SoundComplete = true;      -- SoundComplete; 
		SoloComplete = true;       -- SoloComplete;  
		PartyComplete = true;      -- PartyComplete;
		DMFTestYourStrength = true;-- DarkMoon Faire 250 Grisly Trophy
	}; -- End WorkComplete.Defaults.xxxx
	Options = {
		OneShot = nil;            -- 1-Shot
		PVPHorde = nil;           -- PVPHorde;      
		PVPAlliance = nil;        -- PVPAlliance;   
		SoundReady = nil;         -- SoundReady;    
		SoloReady = nil;          -- SoloReady;     
		PartyReady = nil;         -- PartyReady;    
		SoundComplete = nil;      -- SoundComplete; 
		SoloComplete = nil;       -- SoloComplete;  
		PartyComplete = nil;      -- PartyComplete;
	DMFTestYourStrength = nil; -- DarkMoon Faire 250 Grisly Trophy
	}; -- End WorkComplete.Options.xxxx
	strVersion = nil; -- Version number (text format)
};  -- End WorkComplete.xxxxx

WorkCompleteSaved = {};  --- This will be the data Referenced in the TOC, and Blizzard will save
-- --------------------------------------------------------------------------------------------------------------------------
-- --------------------------------------------------------------------------------------------------------------------------
-- --------------------------------------------------------------------------------------------------------------------------
-- Register Blizzard API Events for use & Display the Addon Loaded Text	
	--   Registers which events the object would like to monitor. 
	--   This ensures the code placed in the <OnEvent> section is not called for 
	--   any unneccessary events such as an incoming chat message when your addon 
	--   is only looking to perform actions based upon the start of casting a spell. 
	--   The last frame to register for an event is the last one to receive it.
	--   SYNTAX:    obj:RegisterEvent(event);  EX.  myChatAddon:RegisterEvent("CHAT_MSG");
	-- --------------------------------------------------------------------------------------------------------------------------
frmMyFrame:RegisterEvent("ADDON_LOADED");
	-- Fires when an addon and its saved variables are loaded. Fires once for each 
	-- addon (i.e. an addon loaded early in sequence will see ADDON_LOADED 
	-- events for all addons loaded later).
	-- --------------------------------------------------------------------------------------------------------------------------
frmMyFrame:RegisterEvent("VARIABLES_LOADED"); 
	-- --------------------------------------------------------------------------------------------------------------------------
frmMyFrame:RegisterEvent("PLAYER_LOGOUT"); --getting lua error for nil value 
	-- --------------------------------------------------------------------------------------------------------------------------
frmMyFrame:RegisterEvent("QUEST_LOG_UPDATE");
	-- This event is fired very often. This includes, but is not limited to: 
	-- viewing a quest for the first time in a session in the Quest Log; 
	-- (once for each quest?) every time the player changes zones across an 
	-- instance boundary; every time the player picks up a non-grey item; 
	-- every time after the player completes a quest goal, such as killing a mob for a quest. 
	-- It also fires whenever the player (or addon using the CollapseQuestHeader
	-- or ExpandQuestHeader() functions) collapses or expands any zone header in the quest log.  
	-- --------------------------------------------------------------------------------------------------------------------------
frmMyFrame:RegisterEvent("UNIT_QUEST_LOG_CHANGED");
	-- Fires when a unit's quests change (accepted/objective progress/abandoned/completed). This event will trigger both for 
	-- your status changes, and that of others (when in a party/raid), and signifies that something has changed regarding the 
	-- unit's current quests. This event triggering means that one of the following has occured: Accepted a new quest, abandoned 
	-- an existing quest, achieved progress on the objectives of a quest, or completed (turned in) a quest.
	-- --------------------------------------------------------------------------------------------------------------------------
frmMyFrame:RegisterEvent("UI_INFO_MESSAGE");
	-- Fires when an informative message should be displayed. 
	-- e.g. "No fish are hooked", "You must be at least level 80 and in a raid group to enter this instance"
	-- Signature: ("message")
	-- Arguments: message - The message that needs to be displayed (string)
	-- --------------------------------------------------------------------------------------------------------------------------
frmMyFrame:RegisterEvent("QUEST_WATCH_UPDATE");
	-- Fires when the player's status regarding a quest's objectives changes, for instance 
	-- picking up a required object or killing a mob for that quest. All forms of (quest objective) 
	-- progress changes will trigger this event.
	-- --------------------------------------------------------------------------------------------------------------------------
frmMyFrame:SetScript("OnEvent", function(self, event, ...)
	if self[event] then return self[event](self, ...); end
	-- Run script whenever an event fires for which the frame is registered. 
    -- In order for this script to be run, the frame must be registered for at 
    -- least one event via its :RegisterEvent() method
    --		OnEvent(self, "event", ...)
    --		Arguments:	
    --		          self - Reference to the widget for which the script was run (frame)
    --		          event - Name of the event (string)
    --		          ... - Arguments specific to the event (list)
    --		
	end)
-- --------------------------------------------------------------------------------------------------------------------------
-- --------------------------------------------------------------------------------------------------------------------------
-- Event Listing functions
-- --------------------------------------------------------------------------------------------------------------------------
function frmMyFrame:ADDON_LOADED(arg1_name)
--
-- this function works once when this addon loads
	if arg1_name == "Work_Complete" then
		DEFAULT_CHAT_FRAME:AddMessage(myRed.."---["..myWhite.."Work_Complete"..myRed.."]---"..myYellow.." ver:"..myGreen..GetAddOnMetadata("Work_Complete", "Version")..myWhite.." by "..myBlue.."PunksNotDead");
		-- check if this is the first time the variables have been loaded
		if (WorkCompleteSaved.OneShot == nil) then
			-- load the defaults
			WorkComplete.Options = WorkComplete.Defaults ;	
			WorkCompleteSaved = WorkComplete.Options;     
			-- print("[Debug Work Complete]----------------->Loaded Default Variables"); 
		else
			-- load the saved variables from the file
			WorkComplete.Options = WorkCompleteSaved;
			-- check if this is the first time for the latest option
			if (WorkComplete.Options.DMFTestYourStrength == nil) then
				WorkComplete.Options.DMFTestYourStrength = true
			end
			-- print("[Debug Work Complete]----------------->Loaded Saved File Variables");
			-- print(WorkComplete.Options.PVPHorde);
			-- print(WorkComplete.Options.PVPAlliance);
			-- print(WorkComplete.Options.SoundReady);
			-- print(WorkComplete.Options.SoloReady);
			-- print(WorkComplete.Options.PartyReady);
			-- print(WorkComplete.Options.SoundComplete);
			-- print(WorkComplete.Options.SoloComplete); 
			-- print(WorkComplete.Options.PartyComplete);
			-- print(WorkComplete.Options.DMFTestYourStrength); 
			-- print("[Debug 215; Work Complete]---------------->End of Saved Variables");
		end --if (WorkCompleteSaved.OneShot == nil) then
		---
		if (WorkComplete.Options.PVPHorde) then
			PlaySoundFile(PVPWarningHorde);
		elseif (WorkComplete.Options.PVPAlliance) then
			PlaySoundFile(PVPWarningAlliance);
		end
		--
		--
		Work_Complete_OptionPanel()    -- Set up Interface Options Panel
		WorkCompleteSetCheckBoxes()    -- Assign the Check Boxes to the Selected Options
	end --if arg1_name == "Work_Complete" then
end --function frmMyFrame:ADDON_LOADED(arg1_name)
-- --------------------------------------------------------------------------------------------------------------------------
function frmMyFrame:VARIABLES_LOADED(arg1_name)
-- this function works once when the saved variables are loaded
	if arg1_name == "Work_Complete" then
		-- print("Debug 233; Variables loaded Event fired");
	end
end 
-- --------------------------------------------------------------------------------------------------------------------------
function frmMyFrame:PLAYER_LOGOUT(arg1_name)
	-- this function works once when the saved variables are loaded
	-- if arg1_name == "Work_Complete" then
	WorkCompleteGetCheckBoxState()
end
-- --------------------------------------------------------------------------------------------------------------------------
function frmMyFrame:UI_INFO_MESSAGE(arg1, arg2)
-- 2016-07-16 Legion Pre-Patch PTR Update.
--  	Function Changed from: UI_INFO_MESSAGE(arg) [arg=message] 
--						   to: UI_INFO_MESSAGE(arg1, arg2) [arg1=unknown number, arg2=message]
-- When a message is output to the screen, the quest info obtained
-- from GetQuestLogTitle/GetQuestLogLeaderBoard isn't updated yet,
-- so we save it here and then look for it later in QUEST_LOG_UPDATE. 
-- This is slightly better than just checking for any changes
-- to previously-saved objectives in QUEST_LOG_UPDATE since it will only check 
-- if there has been recent info messages displayed,
-- and it only checks for exact string matches of the displayed message.
-- 
	strUISentMSG=arg2
end
-- --------------------------------------------------------------------------------------------------------------------------
function frmMyFrame:QUEST_WATCH_UPDATE(questIndex)
	intUpdatedQuestIndex = questIndex
	-- This should contain the Quest number in your log Ex. the number 4
	-- Would mean the 4th line of your quest log (using the L-key)
	if (bolDebug) then
		print("Debug 263 QUEST_WATCH_UPDATE= "..intUpdatedQuestIndex);
	end
end
-- --------------------------------------------------------------------------------------------------------------------------
function frmMyFrame:UNIT_QUEST_LOG_CHANGED(unitID)
	-- Fires when a unit's quests change (accepted/objective progress/abandoned/completed). This event will trigger both for 
	-- your status changes, and that of others (when in a party/raid), and signifies that something has changed regarding the 
	-- unit's current quests. This event triggering means that one of the following has occured: Accepted a new quest, abandoned 
	-- an existing quest, achieved progress on the objectives of a quest, or completed (turned in) a quest.
	--
	-- unitID will be "player" when the event relates to you. This event is VERY reliable for players, and is the preferred event 
	-- when you ONLY care about changes relating to the player's quests and don't care about all the other triggerings that come with 
	-- using the player-only QUEST_LOG_UPDATE (that event should really only be used if you are writing a Quest Log replacement addon, 
	-- as it triggers on many, many non-quest related things).
	--
	-- unitID will be partyX/raidX when the event relates to a party or raid member. However, this event is EXTREMELY unreliable for 
	-- party and raid members, as it will ONLY trigger if you are at a very close range to them; and it will only trigger when they 
	-- GAIN a quest (accepting) or LOSE a quest (abandon/turn in), meaning that you can't expect to use this event to monitor the quest 
	-- status of other units, as you may be out of range when they accept or finish a quest (and then your client won't trigger this event 
	-- and you won't know that they have a new quest/no longer has a certain quest). Also, even if they ARE in range it won't trigger 
	-- for PROGRESS updates (such as finishing or achieving progress on certain objectives). It's best to just completely ignore that 
	-- this event claims to be for other units, as its range limitation makes it useless for keeping an accurate look at other unit's 
	-- quest state.
	--
	-- Note: If you are in a party or raid and YOUR status changes, this event will be triggered twice; once with a unitID of "player", 
	-- and once with your current "partyX/raidX" unitID (be aware that your ID changes whenever the party/raid layout changes; one 
	-- all you may be raid37, and another call you may be raid21, so never store the value and assume it to stay the same).
	-- 
	-- Function updated for due to Patch 6.0.2 API Changes to GetQuestLogTitle function
	--
	local strMSG=""
	local bolWorkComplete = nil
	local bolByPassMSG = False
	local bolCheckString = False
	strPlayerID = unitID
		if (bolDebug) then
			print("Debug 299 - Unit_Quest_Log_Changed unidID=",strPlayerID);
		end
	-- ----------------------------------------------------------------------
	-- First Check if the Quest Log Changed is the players.
	if string.find(strPlayerID, "player") then
		-- Procede by verifing we have a valid message from the UI
	  if ((strUISentMSG ~= nil) and (strUISentMSG ~= ""))then--
		if (bolDebug) then
			print("  --UQLC_1 strUISentMSG= "..strUISentMSG)
		end
		-- Step#0.1 Format the single line of text from the UISentMSG
		-- we need to strip the relevant text out of strUISentMSG using LUA Sting match/formatting
		-- strUISentMSG = String - Message sent to the UI formated like: "Muddy Crawfish: 2/10"
		local mySentMsgText, numUIItems, numUINeeded = string.match(strUISentMSG, "(.*):%s*([%d]+)%s*/%s*([%d]+)");
			if (bolDebug) then
				print("  --UQLU_2: mySentMsgText=", mySentMsgText, ", numUIITems=", numUIItems, ", numUINeeded=", numUINeeded)
			end
		-- Procede if a Quest has been updated.
		if intUpdatedQuestIndex then  -- Quest Number from function frmMyFrame:QUEST_WATCH_UPDATE(questIndex)
			-- Step #1) Determine If The Quest is Complete
			-- We use GetQuestLogTitle to find out if the Quest is Completed
			-- 2014-10-14 Patch 6.0.2 API Update:
				-- API GetQuestLogTitle(intUpdatedQuestIndex) 
				-- 	title (patch 6.0.2 was QuestTitle) = string - The title of the quest, or nil if the index is out of range.
				-- 	level = Integer - The level of the quest
				-- 	suggestedGroup = Integer - if questTag is GROUP, the positive number of players suggested for the quest or nil (added in 2.0.3)
				-- 	isHeader = Boolean - 1 if the entry is a header, nil otherwise.
				-- 	isCollapsed = Boolean - 1 if the entry is a collapsed header, nil otherwise.
				-- 	isComplete (patch 6.0.2 was isQuestComplete) = Integer - -1 if quest is (FAILED), +1 if quest is (COMPLETED), nil otherwise.
			local title, level, suggestedGroup, isHeader, isCollapsed, isComplete, frequency, questID, startEvent, displayQuestID, isOnMap, hasLocalPOI, isTask, isStory = GetQuestLogTitle(intUpdatedQuestIndex);	
				if (bolDebug) then
					print ("  --UQLU_3: GetQuestLogTitle: Title =", title, ", isComplete=", isComplete );
				end
			--
			--
			if (isComplete) then
				-- Result Option#1 Completed Quest *************************************************
				-- The Quest is Complete and we are done
				PlaySoundFile(SoundWorkComplete);
				PlaySound("QUESTCOMPLETED");
				if (title ~= nil) then
					strMSG = ("Work Complete! Quest: "..title);
					if (GetNumGroupMembers() > 0) then 
						if (WorkComplete.Options.PartyComplete==true) then      
							SendChatMessage(strMSG, "PARTY")
						end                                      
					elseif (WorkComplete.Options.SoloComplete==true) then
						DEFAULT_CHAT_FRAME:AddMessage(strMSG)
					end
				end
				--- We Do not want to do anything else so exit the function
				intUpdatedQuestIndex = nil
				strUISentMSG=""
			else
			-- Result Option#2 Determine If a Quest Objective has completed
			-- A quest may have more than one objective ( Kill 5 bears, Collect 10 Pelts) s
			-- So we will compare the update UISentMSG objective with one that is in the Quest Log
			--
			-- Modifications 1/6/2012 = Eliminate Spam from DarkMoon Faire Quest**********
				local myStringFindCheck = string.find(strUISentMSG, "Grisly Trophy") 
				-- this will return an integer with the start of the pattern or nil
				bolByPassMSG = False;
				if (myStringFindCheck ~= nil) then
					if (WorkComplete.Options.DMFTestYourStrength==true) then  
						bolByPassMSG = True; 
					end	--if (WorkComplete.Options.DMFTestYourStrength==true) then
				end --if (myStringFindCheck ~= nil)  then
			-- End Add 1/6/2012 ******************************************************
			--
			-- Step#2.2 Obtain the text form the QuestLeaderBoard Objective by stepping though them
			local intLastObjective = GetNumQuestLeaderBoards(intUpdatedQuestIndex) or 0
			-- Returns the number of objectives for a given quest.
			if (bolDebug) then
				print("  --UQLU_4: intLastObjective is ="..intLastObjective);
			end
			-- 
			for boardIndex = 1, intLastObjective  do
				strMSG=""
				if (bolDebug) then
					print("  --UQLU_5: pointer boardIndex=", boardIndex)
				end
				-- This For Loop will examine each Objective contained in the Updated Quest Number
				-- we use GetQuestLogLeaderBoard to find out if a Quest Objective has been Fullfilled.
				local leaderboardTxt, itemType, isObjectiveDone = GetQuestLogLeaderBoard (boardIndex,intUpdatedQuestIndex);
					-- LeaderBoardTxt = String - The text descript of the objective, like: "2/10 Muddy Crawfish"
					-- itemType = String - could be the following things: "item", "object", "monster", "reputation", "log", or "event".
					-- isObjectiveDone = Boolean - nil=objective is not completed, or 1=Complete
					if (bolDebug) then
						print("  --UQLU_6: leaderboardTxt=", leaderboardTxt, ", itemType=",itemType, ", isObjectiveDone=", isObjectiveDone)
					end
				if (leaderboardTxt ~= nil)then  -- patch 6.0.2 getting LUA error for null value sometimes. 
					strMSG = leaderboardTxt;
					-- we need to strip the relevant text out of leaderboardTxt using LUA Sting match/formatting
					local numItems, numNeeded, myLeaderBoardText = string.match(leaderboardTxt, ("(.*)%s*/%s*(%d+)%s*(.*)"))
					if (myLeaderBoardText ~= nil) then -- patch 6.0.2 getting LUA error for null value sometimes.
						-- myLeaderBoardTxt = String - stripped of the front numitem/numneeded, like: "2/10 Muddy Crawfish" becomes "Muddy Crawfish"
						if (bolDebug) then
							print ("  --UQLU_7: myLeaderboardText=", myLeaderBoardText, ", numItems=",numItems, ", numNeeded=",numNeeded);
						end
						-- --------------------------------------------
						-- ** Edit 2014-11-15 --------------------------------------------------
						--    In Patch 6.0.3 sometimes when collecting objective; the string returned from blizzard has " taken" added on the end
						--    so the leaderboardTxt string sent is something like "3/5 Glowing Mushrooms taken" 
						--    and then myLeaderboadtext ends up being "Glowing Mushrooms taken" which won't match so we need to strip off the " taken"
						--    We will use the string search and replace to check for " taken" and replace it with null
						myLeaderBoardText = string.gsub(myLeaderBoardText, " taken","")
						-- ** Edit 2014-12-31 same senario Leaderboard has " collected" on the end in Eng.Quest Spare Parts
						myLeaderBoardText = string.gsub(myLeaderBoardText, " collected","")
						if (bolDebug) then
							print ("  --UQLU_8: myLeaderboardText Cleaned string = ", myLeaderBoardText);
						end
						--	 ** End Edit 2014-11-15 -----------------------------------------------
						--
						-- ** Edit 2014-11-15 Patch 6.0.3 Check for Plural  **************************************
						bolCheckString = False;
						if (mySentMsgText ~= myLeaderBoardText) then
							-- If the Messages do not match we have a special case(s) of checking for Plural/Singular conditions.
							-- --------------------------------------------
							--Case#1 Check Last Word in the String for Plural version
							--   Sometimes the message sent to the UI is singular, and the text sent to the leaderboard is Plural
							--   Ex.  mySentMsgTxt = "Glowing Mushroom",  and myLeaderBoardText = "Glowing Mushrooms"
							--   Check if the strings are inside one another
							--  	Edit 2014-11-23 First Attempt used if (string.find(mySentMsgText, myLeaderBoardText) or string.find(myLeaderBoardText, mySentMsgText)) then
							--		However one quest the two objectives were "10xArmory Cannoball, and 1x Armory Cannon"  so the find command was always finding the
							--		The "Armory Cannon" text inside "Armory Cannonball" objective and screwing up the intent of identifying Plurals
							-- --------------------------------------------
							if((mySentMsgText ~= nil) and (myLeaderBoardText ~= nil))then -- if we have a match don't worry about special cases
								local mySentMsgTextPlural = mySentMsgText.."s"
								local myLeaderBoardTextPlural = myLeaderBoardText.."s"
								if (bolDebug) then
									print("  --UQLU_9: - Plurals =",mySentMsgTextPlural,myLeaderBoardTextPlural)
								end
								if ((mySentMsgTextPlural == myLeaderBoardText) or (mySentMsgText == myLeaderBoardTextPlural))then
									bolCheckString = True;
								end -- if (string.find(mySentMsgText, myLeaderBoardText) or string.find(myLeaderBoardText, mySentMsgText)) then
								-- --------------------------------------------
								-- Case#2 Edit 2014-12-27 Check First Word in a string of words **************************************
								if ((bolCheckString ~= True)) then
									-- ** Edit 2014-12-27 add First Word Plural Check for multi word strings **************************************
									--  Some quests like "Lurkers" the UI sends the first word singular version of the Leaderboard text
									--  Ex. LeaderBoardTxt = Doses of Lurker Venom
									--      SentTxtMsg = Dose of Lurker Venom (singular)
									--  This code will extract the first word of the string, add an "s", then tack on the ending.
									local intStringLength = string.len(mySentMsgText)
									if (intStringLength > 0 )then
										local intFirstSpace = string.find(mySentMsgText, " ")
										if (intFirstSpace ~= nil) then
											local strFirstWord = string.sub(mySentMsgText, 1, (intFirstSpace-1))
											local strRestWords = string.sub(mySentMsgText, intFirstSpace, intStringLength)
												if (bolDebug) then
													print ("  --UQLU_10: strFirstWord =",strFirstWord)
													print ("  --UQLU_11: strRestWords =",strRestWords)
												end
											if (strFirstWord ~= nil) and (strRestWords ~=nil) then
												local mySentMsgTextPlural = strFirstWord .. "s" .. strRestWords 
													if (bolDebug) then
														print ("  --UQLU_12: First Word Plural SentMsgText =",mySentMsgTextPlural)
													end
												if ((mySentMsgTextPlural == myLeaderBoardText)) then
													bolCheckString = True;
													if (bolDebug) then
														 print ("  --UQLU_13: Found First Word Plural =",mySentMsgTextPlural)
													end
												end 
											end
										end
									end
								end --If (bolCheckString ~= True)then
							end -- if((mySentMsgText ~= nil) and (myLeaderBoardText ~= nil))then
						end --if (mySentMsgText ~= myLeaderBoardText) then
						-- ** End Edit 2014-11-15 Patch 6.0.3 Check for Plural  ************************************************************ 
						-- 
						-- Step#2.4 Compare the text strings from UISent to the QuestLeaderBoard Objective
						if ((bolCheckString == True) or (mySentMsgText == myLeaderBoardText) or (mySentMsgText == myLeaderBoardText.." ("..COMPLETE..")")) then
							-- We have Matched the UI Message OutPut to the Quest Leader Board Change
							-- So we now know that we are dealing with the correct quest objective
						-- Step#2.4 Determine if the Objective is done or Progress was made
							if (isObjectiveDone) then
								-- The Quest is not over - but we completed one of the objectives
								PlaySoundFile(SoundWorkComplete);
								if (strMSG ~= nil) then
									strMSG = ("Work Complete! Objective: "..strMSG);
									if (GetNumGroupMembers() > 0) then 
										if (WorkComplete.Options.PartyComplete==true) then
											SendChatMessage(strMSG, "PARTY")
										end
									elseif (WorkComplete.Options.SoloComplete==true) then
										DEFAULT_CHAT_FRAME:AddMessage(strMSG)
									end
								end --if (strMSG ~= nil)
							else
								-- We have made quest objective progression only
								if (bolByPassMSG==True) then -- Check if bypass is set ex.Grisly Trophy Quest
									-- Do Not Play or Write "Ready To Work
								else 
									if (WorkComplete.Options.SoundReady==true) then
										PlaySoundFile(SoundReadyToWork);
									end
									if (strMSG ~= nil) then
										strMSG = ("Ready To Work: "..strMSG);
										if (GetNumGroupMembers() > 0) then
											if (WorkComplete.Options.PartyReady==true) then
												SendChatMessage(strMSG, "PARTY")
											end
										elseif (WorkComplete.Options.SoloReady==true) then 
											DEFAULT_CHAT_FRAME:AddMessage(strMSG)
										end
									end --if (strMSG ~= nil) then
								end --if (bolByPassMSG==True) then 
							end --if (isObjectiveDone) then
							--
							--
						end --if ((bolCheckString == True) or (mySentMsgText == myLeaderBoardText) or (mySentMsgText == myLeaderBoardText.." ("..COMPLETE..")")) then
						-- We have found the correct objective so bail out of the Loop
						boardIndex = intLastObjective + 1
					end --if (myLeaderBoardText ~= nil) then
				end -- check for nil value; if (leaderboardTxt ~= nil)then
			end -- for boardIndex = 1, intLastObjective  do
			end -- if (isComplete) then
		end -- if intUpdatedQuestIndex then
	  end -- if (strUISentMSG ~= nil) then 
	  intUpdatedQuestIndex = nil
	  strUISentMSG=""
	  --
	  if (bolDebug) then
		print("----------------------- End Debug of Unit_Quest_Log_Changed ---");
	  end
	end -- if string.find(strPlayerID, "player") then
end
-- --------------------------------------------------------------------------------------------------------------------------
function frmMyFrame:QUEST_LOG_UPDATE(...)
--
-- Fires when the game client receives updates relating to the player's quest log (this event is not just related to the quests inside it). 
-- There are a LOT of various things that cause the server to send quest log information to the player's client, such as: Logging into the 
-- game world, zoning between servers (anytime you see a loading screen), accepting quests, deleting/abandoning quests, completing quests, 
-- quest progress updates (achieving whole or partial objective updates for a quest), when dailies reset (the "You can only complete 25 more 
-- daily quests today" event), and whenever something regarding the DISPLAY of the quest log VISUALLY changes (such as when you collapse or 
-- expand headers in the quest log; with headers being the lines such as "Terokkar Forest", that separate the quests into groups).
--		This event (QUEST_LOG_UPDATE) should therefore only be used if you care about the QUEST LOG itself more than the quests; ie if you 
-- implement a custom quest log, then you'd use this event to update the display when things like dailies reset or headers change.
--		However, if you are ONLY interested in tracking QUEST-related information (accepting quests, abandoning quests, achieving quest 
-- progress, and completing quests), there's a better event: UNIT_QUEST_LOG_CHANGED.
-- ----------------------------------------------------------------------------------------------------------------------------
--
-- Rev.2015-07-11 Patch 6.2 Taanaan Jungle Dailies = Problems with this function
-- MOVED CODE TO function frmMyFrame:UNIT_QUEST_LOG_CHANGED(unitID)
--
end --End Function
-- --------------------------------------------------------------------------------------------------------------------------
-- panel.parent - string (optional)
--	Name of the parent of the AddOn or group of configuration options. 
--	This identifies "panel" as the child of another category.
--	If the parent category doesn't exist, "panel" will be displayed as a regular category.
--
-- panel.okay - function (optional)
--	This method will run when the player clicks "okay" in the Interface Options. 
--
-- panel.cancel - function (optional)
--	This method will run when the player clicks "cancel" in the Interface Options. 
--	Use this to revert their changes.
--
-- panel.default - function (optional)
--	This method will run when the player clicks "defaults". 
--	Use this to revert their changes to your defaults.
--
-- panel.refresh - function (optional)
--  This method will run when the Interface Options frame calls its OnShow function and after defaults
--  have been applied via the panel.default method described above.
--  Use this to refresh your panel's UI in case settings were changed without player interaction.
--
-- UI Option Panel Functions
-- --------------------------------------------------------------------------------------------------------------------------
function Work_Complete_OptionPanel()
-- local setting = "1";
  --[[ Create a frame to use as the panel ]] -- 
  -- The new Interface Options frame allows authors to place their configuration
  -- frames (aka "panels") alongside the panels for modifying the default UI.
  --
  local WCpanel = CreateFrame("FRAME", "ExamplePanel");
  -- panel.name - string (required)	
  WCpanel.name = "Work Complete";  --	This is the text that will display in the AddOn options list.
  -- Once a frame is ready to be used as a panel, it must be registered using the function
  -- InterfaceOptions_AddCategory, i.e. InterfaceOptions_AddCategory(panel)               
  InterfaceOptions_AddCategory(WCpanel);
  --
  ---                                                                                                                                                 
-- local VolumeText = WCpanel:CreateFontString("Work_Complete_Global_Text","ARTWORK","GameFontNormal");
-- VolumeText:SetPoint("TOPLEFT", 170, -195);
--
-- VolumeText:SetText("");                                                                                                                         
  --   
  --Signature:
  --                                                                                                              
  --fontstring = Frame:CreateFontString(["name" [, "layer" [, "inherits"]]])                                      
  --Arguments:                                                                                                                                                                                                                                                 
  ------  
  ----name - Global name for the new font string (string)
  ----layer - Graphic layer on which to create the font string; defaults to ARTWORK if not specified (string, layer)
  ----inherits - Name of a template from which the new front string should inherit (string)
 local strWork_Complete_Version = WCpanel:CreateFontString("varWork_Complete_Global_Text","ARTWORK","GameFontNormalLarge");                                           
 strWork_Complete_Version:SetPoint("TOPLEFT", 20, -5);                                                                                                
 strWork_Complete_Version:SetText("Work_Complete v:".. GetAddOnMetadata("Work_Complete", "Version"));  
 
 --   You can make a checkbox in WoW via the following commands:
 --     myCheckButton = CreateFrame("CheckButton", "myCheckButton_GlobalName", parentFrame, "ChatConfigCheckButtonTemplate")
 --  
 --   This is where you locate the checkbox relative to its parent frame. Coordinates are (0,0) is the top-left corner of 
 --   the parent, so a negative y-coordinate means down and positive x-coord means right.
 --     myCheckButton:SetPoint("TOPLEFT", 200, -65);
 --  You can reference the name of your Check Box either by writing it explicitly, or by making a function call. 
 --  Writing it explicitly "looks prettier", but might be confusing to anyone looking at your code, as the name for it seems made-up. 
 --  Note arg2 in the creation call. It is the same as what is below, but we have appended it with "Text". This is necessary, 
 --  I don't know why they didn't just set it up so you can do myCheckButton:Text, but we must work with what we're given.
 --  
 --    myCheckButton_GlobalNameText:SetText("CheckBox Name");
 --  Here is the code to do the exact same thing, but it's not explicitly written. This is (arguably) less confusing.
 --    getglobal(myCheckButton:GetName() .. 'Text'):SetText("CheckBox Name"); 
 --
 --  When mousing over your checkbox, you can have a tooltip appear, which is useful to describe the actions resulting from 
 --  clicking the checkbox, without putting it all in the name.
 --   myCheckButton.tooltip = "This is where you place MouseOver Text.";
 -- 
 if (myOptionTxt1 == nil) then
     myOptionTxt1 = WCpanel:CreateFontString( nil, "ARTWORK", "GameFontGreen" )
     myOptionTxt1:SetPoint( "TOPLEFT", 10, -30 )
     myOptionTxt1:SetText( "Play Sound when Addon is Loaded -------------------------------------------------------" )
 end
 if (myOptionBox01 == nil) then
    myOptionBox01 = CreateFrame("CheckButton", "globalVarWC_Opt1_Button", WCpanel, "ChatConfigCheckButtonTemplate");
    myOptionBox01:SetPoint("TOPLEFT", 15, -40) 
    myOptionBox01:SetWidth(30)
    myOptionBox01:SetHeight(30)                                                                                                                                                                                           
    getglobal(myOptionBox01:GetName().."Text"):SetText("Horde PVP Warning Sound");
    myOptionBox01.tooltip = "Plays the PVP warning sound if the Addon Successfully loads into memory";
 end
 -- Special Case Because Option 1 & 2 (Horde v Alliance) are complementary
  myOptionBox01:SetScript("OnClick", 
  function()
	if( myOptionBox01:GetChecked() ) then 
		myOptionBox01:SetChecked(true)
		myOptionBox02:SetChecked(false)
	end -- Endif
  end);-- Function checkbox "onClick"
 -- 
 if (myOptionBox02 == nil) then
    myOptionBox02 = CreateFrame("CheckButton", "globalVarWC_Opt2_Button", WCpanel, "ChatConfigCheckButtonTemplate");
    myOptionBox02:SetPoint("TOPLEFT", 300, -40) 
    myOptionBox02:SetWidth(30)
    myOptionBox02:SetHeight(30)                                                                                                                                                                                           
    getglobal(myOptionBox02:GetName().."Text"):SetText("Alliance PVP Warning Sound");
    myOptionBox02.tooltip = "Plays the PVP warning sound if the Addon Successfully loads into memory";
 end
  -- Special Case Because Option 1 & 2 (Horde v Alliance) are complementary
  myOptionBox02:SetScript("OnClick", 
  function()
    if( myOptionBox02:GetChecked() ) then
  		-- Alliance Selected so De-Select Horde
  		myOptionBox01:SetChecked(false)
		myOptionBox02:SetChecked(true)
	end -- Endif
  end); -- Function checkbox "onClick"
-- --------------------------------------------------------------------------------------------------------------------------
--- Quest Progression Option Bits
 if (myOptionTxt2 == nil) then
     myOptionTxt2 = WCpanel:CreateFontString( nil, "ARTWORK", "GameFontGreen" )
     myOptionTxt2:SetPoint( "TOPLEFT", 10, -100 )
     myOptionTxt2:SetText( "Quest Objective Progress --------------------------------------------------------------" )
 end
 if (myOptionBox03 == nil) then
    myOptionBox03 = CreateFrame("CheckButton", "globalVarWC_Opt3_Button", WCpanel, "ChatConfigCheckButtonTemplate");
    myOptionBox03:SetPoint("TOPLEFT", 15, -110) 
    myOptionBox03:SetWidth(30)
    myOptionBox03:SetHeight(30)                                                                                                                                                                                           
    getglobal(myOptionBox03:GetName().."Text"):SetText("Play Sound 'Ready To Work' when a quest objective is met.");
    myOptionBox03.tooltip = "Plays sound when a quest objective (item/kill/etc) is achieved.";
 end
  if (myOptionBox04 == nil) then
    myOptionBox04 = CreateFrame("CheckButton", "globalVarWC_Opt4_Button", WCpanel, "ChatConfigCheckButtonTemplate");
    myOptionBox04:SetPoint("TOPLEFT", 15, -140) 
    myOptionBox04:SetWidth(30)
    myOptionBox04:SetHeight(30)                                                                                                                                                                                           
    getglobal(myOptionBox04:GetName().."Text"):SetText("Solo: Write Quest Progress to Chat");
    myOptionBox04.tooltip = "UnCheck to reduce SPAM in Chat";
 end
 if (myOptionBox05 == nil) then
    myOptionBox05 = CreateFrame("CheckButton", "globalVarWC_Opt5_Button", WCpanel, "ChatConfigCheckButtonTemplate");
    myOptionBox05:SetPoint("TOPLEFT", 300, -140) 
    myOptionBox05:SetWidth(30)
    myOptionBox05:SetHeight(30)                                                                                                                                                                                           
    getglobal(myOptionBox05:GetName().."Text"):SetText("Party Chat: Write Progress when grouped");
    myOptionBox05.tooltip = "UnCheck to reduce SPAM in Party Chat";
 end
 ---
 --- Quest Complete Option Bits
 if (myOptionTxt3 == nil) then
     myOptionTxt3 = WCpanel:CreateFontString( nil, "ARTWORK", "GameFontGreen" )
     myOptionTxt3:SetPoint( "TOPLEFT", 10, -200 )
     myOptionTxt3:SetText( "Quest Completed! ----------------------------------------------------------------------" )
 end
 if (myOptionBox06 == nil) then
    myOptionBox06 = CreateFrame("CheckButton", "globalVarWC_Opt6_Button", WCpanel, "ChatConfigCheckButtonTemplate");
    myOptionBox06:SetPoint("TOPLEFT", 15, -210) 
    myOptionBox06:SetWidth(30)
    myOptionBox06:SetHeight(30)                                                                                                                                                                                           
    getglobal(myOptionBox06:GetName().."Text"):SetText("Play Sound 'Work Complete!' when a quest is completed.");
    myOptionBox06.tooltip = "If you are trying to un-Check this box then you probably don't want this Addon at all.";
    myOptionBox06:SetChecked()
    myOptionBox06:Disable()
    
 end
  if (myOptionBox07 == nil) then
    myOptionBox07 = CreateFrame("CheckButton", "globalVarWC_Opt7_Button", WCpanel, "ChatConfigCheckButtonTemplate");
    myOptionBox07:SetPoint("TOPLEFT", 15, -240) 
    myOptionBox07:SetWidth(30)
    myOptionBox07:SetHeight(30)                                                                                                                                                                                           
    getglobal(myOptionBox07:GetName().."Text"):SetText("Solo: Display message in Chat");
    myOptionBox07.tooltip = "UnCheck to reduce SPAM in Chat";
 end
 if (myOptionBox08 == nil) then
    myOptionBox08 = CreateFrame("CheckButton", "globalVarWC_Opt8_Button", WCpanel, "ChatConfigCheckButtonTemplate");
    myOptionBox08:SetPoint("TOPLEFT", 300, -240) 
    myOptionBox08:SetWidth(30)
    myOptionBox08:SetHeight(30)                                                                                                                                                                                           
    getglobal(myOptionBox08:GetName().."Text"):SetText("Party Chat: Display message grouped");
    myOptionBox08.tooltip = "UnCheck to reduce SPAM in Party Chat";
 end
 -- Added 1/2/2012
 ---
    --- Quest Complete Option Bits
    if (myOptionTxt4 == nil) then
        myOptionTxt4 = WCpanel:CreateFontString( nil, "ARTWORK", "GameFontGreen" )
        myOptionTxt4:SetPoint( "TOPLEFT", 10, -300 )
        myOptionTxt4:SetText( "Disable Specific Quest Objectives ----------------------------------------------------------------" )
    end
    if (myOptionBox09 == nil) then
       myOptionBox09 = CreateFrame("CheckButton", "globalVarWC_Opt9_Button", WCpanel, "ChatConfigCheckButtonTemplate");
       myOptionBox09:SetPoint("TOPLEFT", 15, -310) 
       myOptionBox09:SetWidth(30)
       myOptionBox09:SetHeight(30)                                                                                                                                                                                           
       getglobal(myOptionBox09:GetName().."Text"):SetText("Dark Moon Faire: Test Your Strength xxx/250 Grisly Trophy");
       myOptionBox09.tooltip = "UnCheck to show Grisly Trophy progression";
    end
 -- End Add 1/2/2012
 -- --------------------------------------------------------------------------------------------------------------------------
 -- ----------- About Display ---------------------------
 local myAboutTxt01 = WCpanel:CreateFontString("varWork_Complete_About01_Text","ARTWORK","GameFontGreen");                                           
 myAboutTxt01:SetPoint("TOPLEFT", 40, -450);
 myAboutTxt01:SetText("About:");
 local myAboutTxt02 = WCpanel:CreateFontString("varWork_Complete_About02_Text","ARTWORK","GameFontNormalSmall");
 myAboutTxt02:SetPoint("TOPLEFT", 20, -460);
 myAboutTxt02:SetText("Author:"..myBlue.." PunksNotDead");
 local myAboutTxt03 = WCpanel:CreateFontString("varWork_Complete_About03_Text","ARTWORK","GameFontNormalSmall");
 myAboutTxt03:SetPoint("TOPLEFT", 20, -470);
 myAboutTxt03:SetText("Credits:"..myWhite.." FlexYourHead, VooDooMon, Matsu, Probie [RIP Aug.7, 2012]");  
 local myAboutTxt04 = WCpanel:CreateFontString("varWork_Complete_About04_Text","ARTWORK","GameFontNormalSmall");
 myAboutTxt04:SetPoint("TOPLEFT", 20, -480);
 myAboutTxt04:SetText("WebSite:"..myWhite.." www.SevenYearOldTwinkies.com"); 
 local myAboutTxt05 = WCpanel:CreateFontString("varWork_Complete_About53_Text","ARTWORK","GameFontNormalSmall");
 myAboutTxt05:SetPoint("TOPLEFT", 20, -490);
 myAboutTxt05:SetText("License:"..myWhite.." All rights reserved (See license.txt)"); 
 ---
 --- WorkCompleteSetCheckBoxes()
 --- Option Panel Control Buttons from Blizzard
	WCpanel.okay =
	function(self)   
		WorkCompleteGetCheckBoxState()
	end       
	---
	WCpanel.cancel = function (self)
			-- Do Nothing
	end
	---
	WCpanel.default =
	  function (self)
	  	-- The Default is all options Checked + Horde Startup Sound
	  	WorkCompleteLoadDefault()   
	  end                 	    
	 ---
end -- End Function Work_Complete_OptionPanel()
-- --------------------------------------------------------------------------------------------------------------------------
function WorkCompleteLoadDefault()
	-- Set The Options = Defaults 
	-- by Setting the Check box state
	myOptionBox01:SetChecked(true)  
	myOptionBox02:SetChecked(false) 
	myOptionBox03:SetChecked(true)  
	myOptionBox04:SetChecked(true)  
	myOptionBox05:SetChecked(true)  
	myOptionBox06:SetChecked(true)  
	myOptionBox06:Disable()         
	myOptionBox07:SetChecked(true)  
	myOptionBox08:SetChecked(true)  
	myOptionBox09:SetChecked(true)
	--
	WorkCompleteGetCheckBoxState()
end -- Function WorkCompleteLoadDefault()
 -- --------------------------------------------------------------------------------------------------------------------------
function WorkCompleteGetCheckBoxState()
	-- Get the state of the check boxes and update the Option.bits
	if (myOptionBox01:GetChecked()) then  WorkComplete.Options.PVPHorde = true; else  WorkComplete.Options.PVPHorde = false; end
	if (myOptionBox02:GetChecked()) then  WorkComplete.Options.PVPAlliance = true; else  WorkComplete.Options.PVPAlliance = false; end
	if (myOptionBox03:GetChecked()) then  WorkComplete.Options.SoundReady = true; else  WorkComplete.Options.SoundReady = false; end
	if (myOptionBox04:GetChecked()) then  WorkComplete.Options.SoloReady = true; else  WorkComplete.Options.SoloReady = false; end
	if (myOptionBox05:GetChecked()) then  WorkComplete.Options.PartyReady = true; else  WorkComplete.Options.PartyReady = false; end
	if (myOptionBox06:GetChecked()) then  WorkComplete.Options.SoundComplete = true; else  WorkComplete.Options.SoundComplete = false; end
	if (myOptionBox07:GetChecked()) then  WorkComplete.Options.SoloComplete = true; else  WorkComplete.Options.SoloComplete = false; end      
	if (myOptionBox08:GetChecked()) then  WorkComplete.Options.PartyComplete = true; else  WorkComplete.Options.PartyComplete = false; end  
	if (myOptionBox09:GetChecked()) then  WorkComplete.Options.DMFTestYourStrength = true; else  WorkComplete.Options.DMFTestYourStrength = false; end
	if (bolDebug) then
		print ("[Debug 802 Work Complete] Options obtained from checkboxes");
		print("PVPHorde= ",WorkComplete.Options.PVPHorde);
		print("PVPAlliance= ",WorkComplete.Options.PVPAlliance);
		print("SoundReady= ",WorkComplete.Options.SoundReady);
		print("SoloReady= ",WorkComplete.Options.SoloReady);
		print("PartyReady= ",WorkComplete.Options.PartyReady);
		print("SoundComplete= ",WorkComplete.Options.SoundComplete);
		print("SoloComplete= ",WorkComplete.Options.SoloComplete);
		print("PartyComplete= ",WorkComplete.Options.PartyComplete);
		print("DMFTestYourStrength= ",WorkComplete.Options.DMFTestYourStrength);
	end
	WorkCompleteSaved = WorkComplete.Options;
end -- function WorkCompleteGetCheckBoxState()
-- --------------------------------------------------------------------------------------------------------------------------
function WorkCompleteSetCheckBoxes()
  -- this Function sets the Checkboxes State equal to WorkComplete.Options
  getglobal("myOptionBox01"):SetChecked(WorkComplete.Options.PVPHorde);     
  getglobal("myOptionBox02"):SetChecked(WorkComplete.Options.PVPAlliance);  
  getglobal("myOptionBox03"):SetChecked(WorkComplete.Options.SoundReady);   
  getglobal("myOptionBox04"):SetChecked(WorkComplete.Options.SoloReady);    
  getglobal("myOptionBox05"):SetChecked(WorkComplete.Options.PartyReady);   
  getglobal("myOptionBox06"):SetChecked(WorkComplete.Options.SoundComplete);
  getglobal("myOptionBox07"):SetChecked(WorkComplete.Options.SoloComplete); 
  getglobal("myOptionBox08"):SetChecked(WorkComplete.Options.PartyComplete);
  getglobal("myOptionBox09"):SetChecked(WorkComplete.Options.DMFTestYourStrength);
end -- function WorkCompleteSetCheckBoxes()
-- --------------------------------------------------------------------------------------------------------------------------
-- Create slash commands
-- --------------------------------------------------------------------------------------------------------------------------
SLASH_WORK_COMPLETE1 = "/workcompletedebug" -- Uniqued Identifier ADDONNAME_COMMANDNAME = Slash Command in Game emotes
-- Slash Command Handler Function (taking (msg, editbox) as arguments), and place assign it to SlashCmdList["MYADDON"].
function SlashCmdList.WORK_COMPLETE(msg, editbox)
    if (bolDebug == true) then
		bolDebug = false
	else
		bolDebug = true
	end
	if (bolDebug) then
		print("Work_Complete Debug is ON", bolDebug);
	else
		print("Work_Complete Debug is OFF", bolDebug);
	end
end